
# CTF-Style Training Content for CyTrONE

The cybersecurity training content included in this package is created
and maintained by the Cyber Range Organization and Design (CROND)
NEC-endowed chair at the Japan Advance Institute of Science and
Technology (JAIST), Ishikawa, Japan. The content is intended for use
with the CyTrONE integrated cybersecurity training framework that we
also develop; for details, and to download CyTrONE, see the
corresponding page on our GitHub web site:
https://github.com/crond-jaist/cytrone/

The training content provided was designed with reference to the
Capture the Flag (CTF) type of competitions, and questions are
organized in the five categories listed below:

* **Binary**: Analyze executable and non-executable binary files, such
    as programs, images and sound files
* **Cryptography**: Decipher encoded messages
* **Network**: Analyze network packet capture files
* **Operating system**: Use OS management commands, such as `ps`,
    `top`, `netstat`, etc.
* **Web**: Perform attacks on web pages, such as SQL injection and XSS

For each CTF category, both an English and a Japanese version of the
questions are provided. In time we plan to add more and more
questions, and the current question count per category is as follows:

| Category         | Question Count |
|------------------|:--------------:|
| Binary           |       7        |
| Cryptography     |       8        |
| Network          |       8        |
| Operating system |       7        |
| Web              |       8        |
| *TOTAL*          |     *38*       |


## Prerequisites

CyTrONE and its related modules, especially CyRIS, are required to use
the included training content as such. For most of the content, a
virtual machine (VM) image for CyRIS with only a CLI environment is
sufficient, but some of the questions assume the use of a VM with a
GUI desktop environment. You can download such VM images via the link
"*releases*" on the GitHub web page for CyRIS:

* `basevm.tgz` for a CLI environment only VM image
* `basevm_x.tgz` for a GUI environment VM image (the MATE Desktop
  Environment is used)

After download, the VM images must be installed into the appropriate
directory of your CyTrONE/CyRIS setup. The direct link at the time of
writing for the latest CyRIS release, that includes the VM images
mentioned above, is:
https://github.com/crond-jaist/cyris/releases/tag/1.1


## Setup

Follow the steps below in order to install the CTF-style training
content in CyTrONE:

* Copy the included `ctf/` directory into the `cytrone/database/`
  folder of your CyTrONE setup
* Update the CyTrONE training database by using as reference the files
  `ctf/training-en.yml.ctf` (for English) and
  `ctf/training-ja.yml.ctf` (for Japanese)

For further details about CyTrONE and CyRIS, please consult the
relevant user guides.


## Authors/maintainers

* Authors (in alphabetical order of last name)
  - Fumikazu "awar" Awa
  - Ken-ichi Chinen
  - Gen "komagen" Komatsu
  - Wataru "watal" Mishima
  - Masanori "rive3" Sunagawa
  - Kien Chi Vu

* Testers
  - Shinnosuke "crayshin" Kadowaki
  - Yuma "codechin" Kodera

* Maintainers
  - Fumikazu "awar" Awa
  - Razvan Beuran
