#!/bin/bash

# Archive name
ARCHIVE_NAME="file06.zip"

# Directory structure parameters
MAX_DIRS=10
MAX_FILES=15
FILE_SIZE=28 # Match flag length :-)

# Password parameters
PASSWORD="secret"
PASSWORD_FILE="password=${PASSWORD}"
PASSWORD_FILE_DIR_INDEX=5

# Flag parameters
FLAG="flag{ShouldEncryptFileNames}"
FLAG_DIR_INDEX=7
FLAG_FILE_INDEX=7

# Generate a string of random characters with given length
rand_chars () {
    local string=`LC_ALL=C tr -dc 'A-Za-z0-9' < /dev/urandom | fold -w ${1} | head -n 1`
    echo "${string}"
}

# Create the files to be archived
for (( i=1;  i<=${MAX_DIRS}; i++ ))
do
    # Make directory
    mkdir dir${i}

    # Create files in the new directory
    for (( j=1;  j<=${MAX_FILES}; j++ ))
    do
	# Generate a random file name
	FILE_NAME=$(rand_chars 8).$(rand_chars 3)
	echo $(rand_chars ${FILE_SIZE}) > dir${i}/${FILE_NAME}
	if [ ${i} -eq ${FLAG_DIR_INDEX} ]
	then
	    if [ ${j} -eq ${FLAG_FILE_INDEX} ]
	    then
		# Output the flag in the designated dir & file
		echo ${FLAG} > dir${i}/${FILE_NAME}
	    fi
	fi
    done

    # Create the password file in the designated directory
    if [ ${i} -eq ${PASSWORD_FILE_DIR_INDEX} ]
    then
	echo $(rand_chars ${FILE_SIZE}) > dir${i}/${PASSWORD_FILE}
    fi
done

# Create the archive
rm ${ARCHIVE_NAME}
zip --password ${PASSWORD} -r ${ARCHIVE_NAME} dir*

# Do cleanup
for (( i=1;  i<=${MAX_DIRS}; i++ ))
do
    rm -r dir${i}
done
